<?xml version='1.0' encoding='utf-8'?>
| <!DOCTYPE rfc SYSTEM "rfc2629-xhtml.ent" [
// external reference to RFCs
<!ENTITY rfc2119 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.2119.xml">
<!ENTITY rfc3629 SYSTEM "http://xml.resource.org/public/rfc/bibxml/reference.RFC.3629.xml">
<!ENTITY rfc5234 SYSTEM "http://xml2rfc.tools.ietf.org/public/rfc/bibxml/reference.RFC.5234.xml">
// local reference to another doc
| ]>

// processing instructions
<?rfc toc="yes"?>
<?rfc symrefs="yes"?>
<?rfc compact="yes"?>
<?rfc subcompact="no"?>
<?rfc strict="no"?>
<?rfc rfcedstyle="yes"?>
<?rfc comments="yes"?>
<?rfc inline="yes"?>


// categories: std | bcp | info | exp | historic
rfc(category='std' number="2417668" consensus='true' ipr='trust200902' docName='ssvg-specification-03' submissionType='be-cem-mro' xml:lang='en' version='3')
  front
    title(abbrev='SSVG Specification') Stateful Scalar Vector Graphics Specification
    author(fullname='Sylvain Fargier' initials='S.F.' role='editor')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
        email sylvain.fargier@cern.ch
    author(fullname='Mathieu Donzé' initials='M.D.')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
        email mathieu.donze@cern.ch
    author(fullname='Matteo Ferrari' initials='M.F.')
      organization CERN
      address
        postal
          street 1, Esplanade des Particules
          code 1217
          city Meyrin
          country Switzerland
        email matteo.ferrari.1@cern.ch
    date(year='2020' day='10' month="February")

    keyword SSVG
    keyword specification

    abstract
      t Stateful Scalar Vector Graphics specification document.

  middle

    section
      name Introduction
      t
        | This document is a requirement specification for Stateful Scalar
        | Vector Graphics (SSVG).

      t
        | SSVG is an extension to #[xref(target="SVG1_1") Scalar Vector Graphics]
        | designed to bring a higher level of abstraction to SVG documents.

      // This one is a 'must' :)
      section
        name Requirements Notation
        t
          | The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
          | "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
          | document are to be interpreted as described in BCP 14,
          | #[xref(target='RFC2119' format='default') RFC2119].

    section
      name Concepts

      t
        | Stateful Scalar Vector Graphics (namely SSVG) brings
        | a logical state to a graphical document.

      aside
        t
          | As an example, this SVG extension may be used to describe in a
          | declarative way the relationship between a graphical pointer
          | angle displayed in a pressure gauge SVG document
          | and the actual pressure level.
        figure
          name Gauge Illustration
          artwork(align='center' type='binary-art' src='ssvg-specification/gauge.svg')

      t(keepWithNext="true")
        | This logical state extension interacts with the graphical elements
        | of the document using three different layers:
      ol
        li
          | #[xref(target="ELT_PROPERTY") Logical properties] declaration in a
          | dedicated #[xref(target="ELT_STATE") logical state] scope.
        li
          | Graphical values
          | #[xref(target="ELT_RELATION") relations] and
          | #[xref(target="ELT_TRANSFORM") transformations].
        li
          | Graphical state
          | #[xref(target="ELT_TRANSITION") transitions and animations].

    section
      name Namespace

      t
        | SSVG elements #[bcp14 MUST] belong to the #[tt= "http://www.cern.ch/ssvg"]
        | #[xref(target="XML_NAMES") namespace].

      t
        | It is #[bcp14 RECOMMENDED] to use default namespace
        | specification on the #[xref(target="ELT_STATE") state] element as
        | described in #[xref(target="XML_NAMES") Namespaces 6.2].

    section
      name DOM interface

      t
        | This document describes the #[xref(target='DOM') DOM] interface
        | that #[bcp14 SHOULD] be implemented on SSVG documents.

      t
        | Since SSVG is an extension to #[xref(target="SVG1_1") SVG]
        | the described interface may not be directly implemented
        | in the #[tt DOM], it #[bcp14 MAY] be implemented on external objects,
        | but #[bcp14 MUST] follow this document requirements.

    section
      name Schema

      t(keepWithNext="true")
        | Here is a #[xref(target='RELAX_NG_COMPACT') Relax-ng compact] schema
        | describing the SSVG syntax:
      figure
        name SSVG Schema
        sourcecode(type="rnc" src="ssvg-specification/ssvg.rnc")

    section
      name Document Structure

      section(anchor='ELT_STATE')
        name The 'state' element

        t
          | The #[tt state] element describes the SVG document state,
          | there #[bcp14 MUST] be only one #[tt state] element per document.

        t
          | This element #[bcp14 MUST] implement the
          | #[xref(target='ELT_STATE_DOM') StateControl DOM interface].

        t #[strong Content model:] this element can contain any number of the following elements, in any order:
        ul
          li #[xref(target='ELT_PROPERTY') property]
          li #[xref(target='ELT_COMPUTED') computed]

        t
          | A single #[xref(target='ELT_TRANSITION') transition] element
          | #[bcp14 MAY] be present as the first #[tt state] element child.

        t #[strong Attributes:]
        ul
          li core attributes as described in #[xref(target='SVG1_1') SVG 5.10]

        section(anchor='ELT_STATE_DOM')
          name StateControl DOM interface

          t
            | The #[tt state] element #[bcp14 MUST] implement the #[tt StateControl]
            | DOM interface and emit #[xref(target='DOM_STATE_EVENTS') state events]
            | whenever its state is modified.

          t(keepWithNext="true")
            | Here is an #[xref(target='WEB_IDL') Interface Definition] for the
            | StateControl DOM interface:
          figure
            name StateControl DOM IDL
            sourcecode(type="idl" src="ssvg-specification/StateControl.idl")

          section(anchor='DOM_SETSTATE')
            name The setState and updateState operations

            t
              | The #[tt setState] and #[tt updateState] operations are the
              | only operations that #[bcp14 MAY] modify the
              | SSVG document logical state.

            t #[strong Parameters]
            ul
              li
                | #[tt state] an object reflecting the property changes to be
                | applied.

            t #[strong Exceptions]
            ul
              li
                t #[tt DOMException], code INVALID_MODIFICATION_ERR
                t raised when invalid property values are provided.

            t
              | The #[tt setState] operation #[bcp14 MUST] set a complete State
              | object, as returned by
              | #[xref(target='DOM_GETSTATE') getState operation].

            t
              | The #[tt updateState] operation #[bcp14 MAY] provide a partial
              | State object, containing only properties to modify, it
              | #[bcp14 MAY] be invoked with #[tt null], #[tt undefined] or
              | #[tt empty object] to trigger a computed properties update.

          section(anchor='DOM_GETSTATE')
            name The getState operation

            t
              | The #[tt getState] operation returns current document logical
              | state.

            t
              | The returned object #[bcp14 MUST] be detached from the current
              | logical state, any modifications #[bcp14 MUST] be ignored.

          section(anchor='DOM_STATE_EVENTS')
            name The 'state' events

            t
              | The #[tt state events] are regular DOM events with a #[tt state]
              | property containing the latest logical state.

            t
              | Those events are #[xref(target='DOM') DOM Level 2 Events] that
              | #[bcp14 MUST] be emitted with each modification, users
              | #[bcp14 MAY] listen to those events using the following code:
            figure
              name State event listener
              sourcecode(type='javascript')
                | stateElement.addEventListener('state', function(event) {
                |   console.log(event.state);
                | });


      section(anchor='ELT_PROPERTY')
        name The 'property' element

        t
          | The #[tt property] element describes a single property of the SVG
          | document, the sum of all its properties and computed-properties
          | is mentioned as the #[tt document state].

        t
          | There #[bcp14 MAY] be several #[tt property] elements in a given
          | #[tt state] element, their order #[bcp14 SHOULD NOT] matter.

        t #[strong Content model:] this element can contain any number of the following elements, in any order:
        ul
          li #[xref(target='ELT_RELATION') relation]
          li #[xref(target='ELT_TRANSFORM') transform]

        t #[strong Attributes:]
        ul
          li core attributes as described in #[xref(target='SVG1_1') SVG 5.10]
          li #[xref(target='ELT_PROPERTY_NAME') name]
          li #[xref(target='ELT_PROPERTY_TYPE') type]
          li #[xref(target='ELT_PROPERTY_MIN_MAX') min/max]
          li #[xref(target='ELT_PROPERTY_VALUES') values]
          li #[xref(target='ELT_PROPERTY_INITIAL') initial]

        section(anchor='ELT_PROPERTY_NAME')
          name The 'name' attribute

          t
            | The #[tt name] attribute is used to identify each property or
            | computed-property, each name #[bcp14 MUST] be unique for a
            | given SVG document.

          t
            | The #[tt name] attribute is #[bcp14 REQUIRED] for each property
            | and computed-property element.

          t
            | Any #[xref(target='RFC3629') UTF-8] character sequence #[bcp14 MAY]
            | be used as a #[tt name], it is #[bcp14 RECOMMENDED] to use
            | plain ascii characters with an homogeneous styling such as
            | kebab or camel-case.

        section(anchor='ELT_PROPERTY_TYPE')
          name The 'type' attribute

          t
            | The #[tt type] attribute is #[bcp14 REQUIRED] for each property
            | and computed-property elements, the following values #[bcp14 MUST]
            | be supported:
          ul
            li #[strong boolean] a boolean value
            li #[strong number] a numeric value
            li #[strong enum] a list of text values
            li #[strong auto] a dynamically typed property

          section(anchor='ELT_PROPERTY_AUTO')
            name The 'auto' property type

            t
              | #[tt auto] typed properties automatically adjust their internal
              | type and input domain to the actual content.

            t
              | When current value is set using a #[em boolean] typed value,
              | the internal type is switched to #[tt boolean].

            t
              | When current value is set using a #[em numeric] typed value,
              | the internal type is switched to #[tt number], the internal
              | range (#[tt min/max]) #[bcp14 MAY] be updated,
              | it #[bcp14 MUST] be enlarged to always fit current value within
              | the domain,
              | the associated #[tt min/max] DOM attributes
              | #[bcp14 SHOULD NOT] be updated.

            t
              | When current value is neither a #[em numeric] nor a #[em boolean]
              | value, the internal type is switched to #[tt enum], the internal
              | enum #[tt values] range containing a single value (current value),
              | the associated #[tt values] DOM attribute
              | #[bcp14 SHOULD NOT] be updated.

            t
              | Previously computed internal ranges #[bcp14 SHOULD] be reset
              | on type changes (ex: overriding a #[tt number] with a #[tt boolean] and
              | then back to #[tt number] should restore initial #[tt min/max] range).

        section(anchor='ELT_PROPERTY_MIN_MAX')
          name The 'min' and 'max' attributes

          t
            | The #[tt min] and #[tt max] attributes is used to define the
            | property's boundary range.

          t
            | Those two attributes are meaningful only with #[tt number]
            | properties, it #[bcp14 MUST] be ignored on any other property
            | types.

          t
            | Those attributes are #[bcp14 OPTIONAL], their default value being
            | #[tt= "[0, 1]"].

          t
            | Having #[tt min] &gt;= #[tt max] is an error, which #[bcp14 MUST]
            | be reported as such, the values #[bcp14 SHOULD] be ignored
            | by the rendering engine.

        section(anchor='ELT_PROPERTY_VALUES')
          name The 'values' attribute

          t
            | The #[tt values] attribute is used to define an #[tt enum] typed
            | property's value range.

          t
            | This attribute is #[bcp14 REQUIRED] on #[tt enum] typed properties,
            | and #[bcp14 MUST] be ignored on any other property
            | type.

          t
            | It #[bcp14 MUST] be a semi-colon separated list of
            | #[xref(target='TARGET_VALUES_STRING') string values].

          t
            | An empty list of values is not valid, and #[bcp14 MAY] not be
            | parsed, a list of values with a single element is valid (as used in
            | #[xref(target='ELT_PROPERTY_AUTO') auto-properties])
            | and #[bcp14 SHOULD] be normalized as #[tt 0].

        section(anchor='ELT_PROPERTY_INITIAL')
          name The 'initial' attribute

          t
            | The #[tt initial] attribute is used to define an initial value
            | for the given property.

          t
            | This attribute is #[bcp14 OPTIONAL] the default value for this
            | property being the first value of the range:
          ul
            li #[tt false] for #[em boolean] typed properties.
            li #[tt min] for #[em number] typed properties.
            li first value for #[em enum] typed properties.

          t
            | The initial value #[bcp14 MUST] be a valid value for the given
            | property type and range.

      section(anchor='ELT_COMPUTED')
        name The 'computed' element

        t
          | The #[tt computed] element inherits its attributes and
          | child-elements from the #[xref(target='ELT_PROPERTY') property]
          | element.

        t
          | In addition to #[tt property] element defined attributes the
          | #[tt computed] element #[bcp14 MAY] have an #[tt onupdate] attribute
          | that is described in its #[xref(target='ELT_COMPUTED_DOM') DOM interface].

        t
          | There #[bcp14 MAY] be several computed properties in a given
          | #[tt state] element.

        t
          | In contrast to #[tt property] elements,
          | their order #[bcp14 MUST] correspond to their processing order,
          | thus it #[bcp14 SHOULD] matter.

        section(anchor='ELT_COMPUTED_DOM')
          name ComputedElement DOM interface

          t
            | The #[tt computed] elements #[bcp14 MUST] implement the
            | #[tt ComputedElement] DOM interface.

          t(keepWithNext="true")
            | Here is an #[xref(target='WEB_IDL') Interface Definition] for the
            | ComputedElement DOM interface:
          figure
            name ComputedElement DOM IDL
            sourcecode(type="idl" src="ssvg-specification/ComputedElement.idl")

          t
            | The #[tt stateEventHandler] callback set on either the #[tt onupdate]
            | DOM property or as an #[em HTML attribute] #[bcp14 MUST] be
            | called once upon each logical-state update.

          t
            | Whenever both values are set (HTML attribute and DOM property),
            | the DOM property #[bcp14 SHOULD] take precedence.

          t
            | When provided as an XML attribute, the engine #[bcp14 SHOULD]
            | support arrow-functions, plain functions and inline computations ;
            | whenever using inline computations the state argument #[bcp14 MUST]
            | be bound to #[tt= "$state"] variable.

          t
            | Whenever the invoked #[tt stateEventHandler] returns a non #[tt undefined]
            | value, the associated #[em computed] property #[bcp14 MUST] be
            | updated with this value ; returning an out-of-range or
            | invalid value for the associated #[em computed] property is an error.

          t
            | The #[tt state] object provided as an argument to
            | #[tt stateEventHandler] callbacks #[bcp14 SHOULD NOT] be modified
            | by the #[tt stateEventHandler] callback, it #[bcp14 MAY] be frozen.

          t
            | The #[tt this] context of the #[tt onupdate] callback #[bcp14 MUST]
            | be bound to the associated #[em computed] DOM Element, #[tt window]
            | and #[tt document] #[bcp14 SHOULD] be bound in relevant contexts.

      section(anchor='ELT_RELATION')
        name The 'relation' element

        t
          | The #[tt relation] element describes a relation between a
          | state #[tt property] and SVG DOM attributes.

        t
          | It is a child element of #[xref(target='ELT_PROPERTY') property] and
          | #[xref(target='ELT_COMPUTED') computed] elements, there #[bcp14 MAY]
          | be several #[tt relation] elements for a given #[tt property] or
          | #[tt computed] element.

        t
          | There #[bcp14 SHOULD] be only one #[tt relation] per SVG DOM
          | attribute (or text-content), creating a 1-to-N relationship from
          | #[tt property] elements to the SVG DOM, rendering #[bcp14 MAY]
          | be inconsistent whenever this rule is not respected.

        t #[strong Content model:] this element can contain the following elements, in any order:
        ul
          li #[xref(target='ELT_TRANSITION') transition]

        t #[strong Attributes:]
        ul
          li core attributes as described in #[xref(target='SVG1_1') SVG 5.10]
          li #[xref(target='ELT_RELATION_SELECTOR') query-selector]
          li #[xref(target='ELT_RELATION_ATTR') attribute-name]
          li #[xref(target='ELT_RELATION_ATTR_TYPE') attribute-type]
          li #[xref(target='ELT_RELATION_FROM_TO') from/to]
          li #[xref(target='ELT_RELATION_BY') by]
          li #[xref(target='ELT_RELATION_VALUES') values]
          li #[xref(target='ELT_RELATION_KEYTIMES') key-times]
          li #[xref(target='ELT_RELATION_CALC_MODE') calc-mode]

        section(anchor='ELT_RELATION_RANGE')
          name The 'relation' element values range

          t
            | The #[xref(target='ELT_RELATION_VALUES') values] attribute defines
            | the #[tt relation] value range.

          t
            | The #[xref(target='ELT_RELATION_FROM_TO') from and to], and with
            | some extent #[xref(target='ELT_RELATION_BY') by] are shorthands
            | to the #[tt values] attribute.

          t
            | If none of those attributes are set, the #[tt relation] value range
            | #[bcp14 MUST] map the associated #[tt property] min/max values.

          section(anchor='ELT_RELATION_RANGE_UNITS')
            name The 'relation' element values range units and qualifiers

            t
              | A value unit or qualifier #[bcp14 MAY] be specified on a given value
              | (e.g. "10px", "20%"), this #[bcp14 SHOULD NOT] be taken into account
              | during the value interpolation, but #[bcp14 MUST] be set on the
              | target attribute.

            t
              | The unit or qualifier is set for the complete range, thus
              | setting a unit or qualifier on a single value #[bcp14 MUST] define it for
              | the complete range.

            t
              | A range #[bcp14 SHALL NOT] have more than one kind of unit or qualifier,
              | it #[bcp14 MAY] be repeated on one or several values of the range
              | specification, but it #[bcp14 MUST] use an identical value.

        section(anchor='ELT_RELATION_SELECTOR')
          name The 'query-selector' attribute

          t
            | The #[tt query-selector] attribute contains a
            | #[xref(target='CSS_SELECTORS') CSS Level 4 selector] that
            | identifies elements within the SVG document.

          t
            | The list of elements selected by this query #[bcp14 SHOULD] be
            | equivalent to a #[tt querySelectorAll] #[xref(target='DOM') DOM4]
            | method call on the main #[tt svg] tag of the SVG document.

          t
            | The selector #[bcp14 MAY] be run only once when the SVG document
            | is loaded.

          // FIXME: should there be an api to run selectors again ?

        section(anchor='ELT_RELATION_ATTR')
          name The 'attribute-name' attribute

          t
            | The #[tt attribute-name] attribute identifies which attribute
            | is targeted by this relation.

          t
            | An empty or missing #[tt attribute-name] identifies the target
            | element #[tt textContent] as described in #[xref(target='DOM') DOM3 Core],
            | making this attribute #[bcp14 OPTIONAL].

        section(anchor='ELT_RELATION_ATTR_TYPE')
          name The 'attribute-type' attribute

          t
            | The #[tt attribute-type] attribute identifies whereas the relation
            | targets a #[xref(target='DOM') DOM attribute] or a
            | #[xref(target='CSS_VALUES') CSS properties].

          t
            | It is similar to the #[xref(target='SMIL') SMIL attributeType attribute]
            | and can have the following values:
          ul
            li #[strong CSS]: the #[em attribute-name] identifies a CSS property.
            li #[strong XML]: the #[em attribute-name] identifies a DOM attribute.
            li
              | #[strong auto]: the #[em attribute-name] is first searched amongst
              | known CSS properties and targets a DOM attribute if no CSS
              | properties matches.

          t
            | This attribute is #[bcp14 OPTIONAL], its default value being #[tt auto].

        section(anchor='ELT_RELATION_VALUES')
          name The 'values' attribute

          t
            | The #[tt values] attribute identifies the target attribute range.

          t
            | It #[bcp14 MUST] be a semi-colon separated list of values,
            | possible values are as described in #[xref(target='TARGET_VALUES')].

          t
            | The defined value range #[bcp14 MUST] be used to compute the
            | current #[tt relation] value by either interpolating the
            | property within the given range or stepping it if the range can't
            | be interpolated.

          t
            | #[tt values] are evenly spread in the specified #[tt property] range, unless
            | a #[xref(target='ELT_RELATION_KEYTIMES') key-times] attribute is specified.

          t
            | Those values represent the different steps in #[tt discrete] #[tt calc-mode]
            | or a sequence of linear interpolation ranges in #[tt linear] #[tt calc-mode].

          t
            | See #[xref(target='EX_RELATION_VALUES')] for a commented example
            | and refer to #[xref(target='VALUES_INTERPOLATION')]
            | for details about value interpolation.

          t
            | This attribute is similar to #[xref(target="SVG1_1") SVG animation values].

        section(anchor='ELT_RELATION_FROM_TO')
          name The 'from' and 'to' attributes

          t
            | The #[tt from] and #[tt to] attributes identify the target
            | attribute range.

          t
            | Those attributes #[bcp14 MUST] be ignored if #[tt values] attribute is set.

          t
            | Using those attributes is roughly equivalent to setting #[tt values]
            | to #[tt= '"from; to"'], defining a #[tt= '[from, to]'] range.

          t
            | #[tt from] is made #[bcp14 OPTIONAL] when #[tt to] is set, it
            | #[bcp14 MUST] be set to the initial value of the first target attribute
            | selected by the relation.

        section(anchor='ELT_RELATION_BY')
          name The 'by' attribute

          t
            | The #[tt by] attribute identifies a relative target attribute range.

          t
            | This attribute #[bcp14 MUST] be ignored if any of #[tt from, to]
            | or #[tt values] attributes are set.

          t
            | Using this attributes is roughly equivalent to
            | defining a #[tt= '[initialValue, initialValue + by]'] range,
            | initialValue being the initial value of the first target attribute
            | selected by the relation.

        section(anchor='ELT_RELATION_KEYTIMES')
          name The 'key-times' attribute

          t
            | The #[tt key-times] attribute defines how #[tt values] should be
            | spread across the generated range.

          t
            | The #[tt key-times] value #[bcp14 MUST] be a list of unit-less
            | scalar values with as many values as the #[tt values] list itself.

          t
            | Those values #[bcp14 MUST] be in #[tt= '[0, 1]'] range,
            | representing a proportional offset in the #[tt property] value
            | range.

          t
            | The first #[tt key-times] value #[bcp14 MUST] be #[tt 0] and the
            | last #[tt 1], the list #[bcp14 MUST] be sorted in ascending order.

          t
            | It is similar to #[xref(target="SVG1_1") SVG animation keyTimes],
            | for additional details on how this attribute is being processed, see
            | #[xref(target='VALUES_INTERPOLATION') Values interpolation].

        section(anchor='ELT_RELATION_CALC_MODE')
          name The 'calc-mode' attribute

          t
            | The #[tt calc-mode] attribute defines how
            | #[xref(target='TARGET_VALUES') target values] #[bcp14 MUST] be
            | interpolated.

          t
            | The following values are valid #[tt calc-mode] values:
          ul
            li #[xref(target='ELT_RELATION_CALC_MODE_LINEAR') linear]
            li #[xref(target='ELT_RELATION_CALC_MODE_DISCRETE') discrete]

          section(anchor='ELT_RELATION_CALC_MODE_LINEAR')
            name The 'linear' calc-mode

            t
              | When #[tt calc-mode] is set to #[tt linear], the #[tt relation] value
              | #[bcp14 MUST] be computed using a linear interpolation of
              | the #[tt property] value from its #[tt= '[min, max]'] range
              | to the #[tt relation] value range.

            t
              | This interpolation #[tt MUST] take into account #[tt key-times],
              | for further details see
              | #[xref(target='VALUES_INTERPOLATION') Values interpolation].

          section(anchor='ELT_RELATION_CALC_MODE_DISCRETE')
            name The 'discrete' calc-mode

            t
              | When #[tt calc-mode] is set to #[tt discrete], the #[tt relation]
              | value #[bcp14 MUST] be computed by stepping in the #[tt relation]
              | value range.

            t
              | This mode is likely to be used along with the
              | #[xref(target='ELT_RELATION_VALUES') values] attribute, only
              | two 'steps' being defined otherwise.

        section(anchor='ELT_RELATION_ONUPDATE')
          name RelationElement DOM interface
          
          t
            | The #[tt relation] elements #[bcp14 MUST] implement the
            | #[tt RelationElement] DOM interface.

          t(keepWithNext="true")
            | Here is an #[xref(target='WEB_IDL') Interface Definition] for the
            | RelationElement DOM interface:
          figure
            name RelationElement DOM IDL
            sourcecode(type="idl" src="ssvg-specification/RelationElement.idl")

          t
            | The #[tt updateEventHandler] callback set on either the #[tt onupdate]
            | DOM property or as an #[em HTML attribute] #[bcp14 MAY] be called
            | at each transition step, it is used as a filter function to
            | modify the target-value just before insertion.
            
          t
            | The #[tt updateEventHandler] callback #[bcp14 SHOULD] be called by
            | the engine only when the un-filtered target-value changes,
            | caching results whenever necessary.

          t
            | Whenever both values are set (XML attribute and DOM property),
            | the DOM property #[bcp14 SHOULD] take precedence.

          t(keepWithNext="true")
            | When implemented as an XML attribute, the engine #[bcp14 SHOULD]
            | support arrow-functions, plain functions and inline computations,
            | Example:
          figure
            name RelationElement onupdate example
            sourcecode(type="idl" src="ssvg-specification/RelationElementExample.xml")

          t
            | Whenever using inline computations, arguments #[bcp14 MUST] be
            | bound to respectively: #[tt= "$value"] and #[tt= "$unit"] variables.

          t
            | The #[tt this] context of the #[tt onupdate] callback #[bcp14 MUST]
            | be bound to the associated #[em relation] DOM Element, #[tt window]
            | and #[tt document] #[bcp14 SHOULD] be bound in relevant contexts.

          t
            | #[strong Note:] this interface #[bcp14 SHOULD] be used with caution
            | since it #[bcp14 MAY] be really CPU intensive.

      section(anchor='ELT_TRANSFORM')
        name The 'transform' element

        t
          | The #[tt transform] element inherits its attributes and
          | child-elements from the #[xref(target='ELT_RELATION') relation element].

        t
          | The #[tt attribute-name] attribute #[bcp14 MUST] default to #[tt transform],
          | to use the default behavior and target the #[tt textContent] one
          | #[bcp14 MUST] explicity set it to the empty string.

        t
          | The #[tt from], #[tt to], #[tt values] and #[tt by] attributes
          | use a dedicated syntax that matches the following
          | #[xref(target="RFC5234") abnf syntax]:
        figure
          name Transform value syntax
          sourcecode(type='abnf')
            | transform-list: *WSP [transforms] *WSP
            | transforms: transform / transform comma-wsp transforms
            | comma-wsp: (1*WSP [","] *WSP) / ("," *WSP)
            |
            | transform: 1*ALPHA *WSP
            |   "(" *WSP *(scalar-val comma-wsp) scalar-val *WSP ")"

        t #[tt scalar-val] is as described in #[xref(target='TARGET_VALUES_SCALAR')].

        t
          | The #[tt values] generated from this #[tt transform-list] #[bcp14 MUST]
          | have identical #[tt transform].

        t
          | Some lists #[tt transform-list] in a given #[tt transform] element
          | #[bcp14 MAY] have less values than others, the missing values
          | #[bcp14 MUST] always be the the last transforms of the sequence
          | and #[bcp14 MUST] be evaluated as zero (as in #[tt 0]) based transforms.

        t
          | #[strong Note:] zero based transforms are not always neutral transfroms
          | (ex: zero based matrix).

        t
          | The generated target value transform string #[bcp14 MUST] be compatible with
          | both #[xref(target='SVG1_1') SVG transforms] and
          | #[xref(target='CSS_TRANSFORMS') CSS transforms].

        t
          | Transforms' names and units #[bcp14 SHOULD] be rendered as-is,
          | thus it is up to the caller to generate a valid transform.

        t
          | #[tt transform] elements #[bcp14 SHOULD NOT] implement
          | #[xref(target='ELT_RELATION_ONUPDATE') RelationElement DOM interface],
          | this #[bcp14 MAY] be changed in a later version of this document.

        section
          name Recommended transforms

          t
            | The following transforms are the most spread ones and compatible
            | with both #[xref(target='SVG1_1') SVG transforms] and
            | #[xref(target='CSS_TRANSFORMS') CSS transforms]:
          ul
            li #[strong translate] using the following syntax: #[tt= "translate(100, 200)"]
            li #[strong scale] using the following syntax: #[tt= "scale(.5, .5)"] or #[tt= "scale(.5)"]

          t
            | The following transforms are also widely used but a different
            | syntax #[bcp14 MUST] be use depending on the target type (CSS or SVG transform attribute):
          ul
            li #[strong rotate]: #[tt= "rotate(90)"] in SVG versus #[tt= "rotate(90deg)"] in CSS.
            li #[strong skewX] or #[strong skewY]: #[tt= "skewX(45)"] in SVG versus #[tt= "skewX(45deg)"] in CSS.

          t
            | Those differences are detailed in
            | #[xref(target='CSS_TRANSFORMS') CSS Transforms (7.3)],
            | it is up to the caller to choose which implementation to use.

      section(anchor='ELT_DIRECT')
        name The 'direct' element
        
        t
          | The #[tt direct] element describes a direct relation between a
          | state #[tt property] and SVG DOM attributes.

        t #[strong Attributes:]
        ul
          li core attributes as described in #[xref(target='SVG1_1') SVG 5.10]
          li #[xref(target='ELT_RELATION_SELECTOR') query-selector]
          li #[xref(target='ELT_RELATION_ATTR') attribute-name]
          li #[xref(target='ELT_RELATION_ATTR_TYPE') attribute-type]

        t
          | Direct elements #[bcp14 MAY] be seen as a short-hand to #[tt relation]
          | elements, a direct element on a #[tt number] typed property
          | being equivalent to a #[tt relation] mapping the #[tt property]
          | domain (#[tt= 'from = min'], #[tt= 'to = max']) ;
          | a direct element on an #[tt enum] or #[tt boolean] typed property being
          | equivalent to a #[tt relation] mapping the #[tt property] values or
          | respectively #[tt "true"] and #[tt "false"] values for enum.

        t
          | Direct elements #[bcp14 SHOULD] adapt to the evolutions of an
          | #[xref(target='ELT_PROPERTY_AUTO') auto] property.

        t
          | #[tt Transition] effects #[bcp14 MUST] be applied on #[tt direct] elements,
          | #[tt number] typed #[tt properties] #[bcp14 SHOULD] be interpolated
          | as scalar target types, other #[tt property] types (#[tt enum], #[tt boolean])
          | #[bcp14 SHOULD] respect the
          | #[xref(target='NON_INTERPOLATABLE_TRANSITION') Non-interpolatable transition] rule.

        t
          | #[tt direct] elements #[bcp14 MUST] implement
          | #[xref(target='ELT_RELATION_ONUPDATE') RelationElement DOM interface],
          | the #[tt unit] argument #[bcp14 SHOULD] always be undefined.

      section(anchor='ELT_TRANSITION')
        name The 'transition' element

        t
          | The #[tt transition] element describes how SVG DOM attributes are
          | animated from one value to another.

        t
          | There #[bcp14 SHOULD] be only one #[tt transition] element per
          | #[xref(target='ELT_RELATION') relation] element.

        t
          | If a #[tt relation] element has more than one #[tt transition]
          | element, they #[bcp14 MUST] be loaded in order, the later attributes
          | overriding any previously set values.

        t
          | If a #[tt transition] element is set on the main
          | #[xref(target='ELT_STATE') state] element, it sets the default
          | transition values for all #[tt relation] elements in the SSVG document.

        t
          | Default values #[bcp14 SHOULD] be considered as if each #[tt relation]
          | element had this #[tt transition] child-element as its first child.

        t #[strong Attributes:]
        ul
          li core attributes as described in #[xref(target='SVG1_1') SVG 5.10]
          li #[xref(target='ELT_TRANSITION_DURATION') duration]
          li #[xref(target='ELT_TRANSITION_TIMING') timing-function]
          li #[xref(target='ELT_TRANSITION_DELAY') delay]
          li #[xref(target='ELT_TRANSITION_TYPE') type]

        section(anchor='ELT_TRANSITION_DURATION')
          name The 'duration' attribute

          t
            | The #[tt duration] attribute defines the total transition duration,
            | its value #[bcp14 MUST] be a #[xref(target='DURATION_VALUES') Duration value].

          t
            | This attribute is #[tt OPTIONAL], its default value #[bcp14 MUST]
            | be #[tt 0s], disabling transitions.

        section(anchor='ELT_TRANSITION_TIMING')
          name The 'timing-function' attribute

          t
            | The #[tt timing-function] attribute defines how values #[bcp14 MUST]
            | be changed by the transition.

          t
            | It #[bcp14 MUST] behave exactly like
            | #[xref(target='CSS_EASING') CSS Easing] functions, and
            | #[bcp14 MUST] support the following values:
          ul
            li #[strong linear]
            li #[strong ease] equivalent to #[tt= 'cubic-bezier(0.25, 0.1, 0.25, 1)']
            li #[strong ease-in] equivalent to #[tt= 'cubic-bezier(0.42, 0, 1, 1)']
            li #[strong ease-out] equivalent to #[tt= 'cubic-bezier(0, 0, 0.58, 1)']
            li #[strong ease-in-out] equivalent to #[tt= 'cubic-bezier(0.42, 0, 0.58, 1)']
            li #[strong cubic-bezier] as described in #[xref(target='CSS_EASING') CSS Easing 2.2]

          // FIXME: should this interact with discrete calc-mode ? providing the stepped feature
          // Too exotic and will probably never be used, do prefer
          t
            | Stepping modes as described in #[xref(target='CSS_EASING') CSS Easing] #[bcp14 SHOULD NOT] be supported.

          t
            | This attribute is #[tt OPTIONAL], its default value #[bcp14 MUST] be
            | #[tt "linear"], having no easing function.

        section(anchor='ELT_TRANSITION_DELAY')
          name The 'delay' attribute

          t
            | The #[tt delay] attribute defines a delay before the transition
            | starts, its value #[bcp14 MUST] be a #[xref(target='DURATION_VALUES') Duration value].

          t
            | The target value #[bcp14 MUST] not change before this delay expires.

          t
            | This attribute is #[tt OPTIONAL], its default value #[bcp14 MUST]
            | be #[tt 0s], not delaying transitions.

        section(anchor='ELT_TRANSITION_TYPE')
          name The 'type' attribute

          t
            | The #[tt type] attribute defines how #[tt relation] values that have
            | a non-linear value range #[bcp14 MUST] be animated.

          t
            | This attribute has an effect only on #[tt relation] elements that
            | have more than two #[xref(target='ELT_RELATION_VALUES') values].

          t
            | The following values #[bcp14 MUST] be supported:
          ul
            li #[xref(target='ELT_TRANSITION_TYPE_DIRECT') direct]
            li #[xref(target='ELT_TRANSITION_TYPE_STRICT') strict]

          t
            | This attribute is #[bcp14 OPTIONAL], its default value #[bcp14 MUST]
            | be #[tt "strict"].

          section(anchor='ELT_TRANSITION_TYPE_DIRECT')
            name The 'direct' transition type

            t
              | In #[tt direct] transition mode, the transition's intermediate
              | values #[bcp14 MUST] be computed using the most
              | direct path from one value to another, most likely using a linear
              | transformation.

            t
              | This linear transformation is the one that would be used on a linear
              | value range #[tt relation] (that has 2 #[tt values] set),
              | achieving the same transition.

          section(anchor='ELT_TRANSITION_TYPE_STRICT')
            name The 'strict' transition type

            t
              | In #[tt strict] transition mode, the transition's intermediate
              | values #[bcp14 MUST] follow the value range defined by the #[tt relation].

            aside
              t
                | As an example, a #[tt relation] that would be have #[tt= 'values="red; green; blue"']
                | having its value changing from #[tt red] to #[tt blue] #[bcp14 MUST] achieve
                | two color transitions, from red to green then to blue.

            t
              | The #[tt transition] #[xref(target='ELT_TRANSITION_DURATION') duration]
              | #[bcp14 MUST] be respected, and corresponds to the total transition duration.

            t
              | The #[tt transition] #[xref(target='ELT_TRANSITION_TIMING') timing-function]
              | #[bcp14 MUST] be applied on each linear transition; in the example above
              | there would have been two #[tt timingFunctions] applied, from the
              | initial value to green, then from green to the final value.

            t
              | The #[tt relation] #[xref(target='ELT_RELATION_KEYTIMES') key-times] #[bcp14 MUST]
              | be respected, splitting the transition duration accordingly.

        section(anchor='NON_INTERPOLATABLE_TRANSITION')
          name Non-interpolatable target-values

          t
            | Transisitions #[bcp14 MUST] be applied to non-interpolatable
            | #[xref(target='TARGET_VALUES') target-values].

          t
            | In #[tt direct] transition mode the target-value #[bcp14 SHOULD]
            | be modified at half the transition duration.

          t
            | In #[tt strict] transition mode the target-value modification
            | thresholds #[bcp14 SHOULD] be defined by the #[tt relation]
            | #[xref(target='ELT_RELATION_KEYTIMES') key-times].

          t
            | #[strong Note:] in #[tt strict] mode, on a simple #[tt relation]
            | (to/from), the value change happens at the end of the transition.

    section(anchor='VALUES')
      name Values and Types

      t
        | This section describes the various values and type syntax that are
        | used in SSVG documents.

      section(anchor='DURATION_VALUES')
        name Duration values

        t
          | #[tt Duration values] are described in seconds or milliseconds
          | (1000 in a second), their canonical unit being the second.

        t
          | #[tt Duration values] syntax #[bcp14 MUST] match the one described in
          | #[xref(target='CSS_VALUES') CSS3 Values 6.2] which is being used
          | on #[xref(target='CSS_TRANSITIONS') CSS Transitions] and matches
          | the following #[xref(target="RFC5234") abnf syntax]:
        figure
          name Duration values
          sourcecode(type='abnf')
            | dur-val = (1*(DIGIT) / [1*(DIGIT)] "." 1*(DIGIT)) [unit]
            |
            | unit = "s" / "ms"

        t
          | #[strong Note:] this syntax is a reduced subset of #[tt Clock values]
          | described in #[xref(target='SMIL') SMIL Animation 3.6.7] that are
          | used in #[xref(target='SVG1_1') SVG 19.2.8.1], this more elaborate
          | syntax #[bcp14 SHOULD NOT] be needed, preferring a lightweight syntax.

      // FIXME: describe that transform uses one or more scalar values with a specific syntax
      section(anchor='TARGET_VALUES')
        name Target values

        t
          | #[tt Target values] are used by #[tt relation] elements to describe
          | the value range, it can be:
        ul
          li A simple #[xref(target='TARGET_VALUES_SCALAR') scalar] value
          li A #[xref(target='TARGET_VALUES_COLOR') color] value
          li A semi-colon separated list of #[xref(target='TARGET_VALUES_STRING') string] value

        section(anchor='TARGET_VALUES_SCALAR')
          name Scalar values

          t
            | Any numeric value that #[bcp14 MAY] have a unit or qualifier specifier
            | and matches the following #[xref(target="RFC5234") abnf syntax]:
          figure
            name Scalar values
            sourcecode(type='abnf')
              | scalar-val =
              |   [sign] ( 1*(DIGIT) / [1*(DIGIT)] "." 1*(DIGIT)) [unit]
              |
              | unit = 1*ALPHA / "%"
              | sign = "+" / "-"

        section(anchor='TARGET_VALUES_COLOR')
          name Color values

          t A color value as described in #[xref(target='CSS_COLOR') CSS Color syntax].

          t Color values #[bcp14 MAY] be interpolated.

        section(anchor='TARGET_VALUES_STRING')
          name String values

          t
            | A single or double-quoted string value that matches the following
            | #[xref(target="RFC5234") abnf syntax]:
          figure
            name String values
            sourcecode(type='abnf')
              | string-val =
              |   DQUOTE *( not-DQUOTE / escaped ) DQUOTE /
              |   QUOTE *( not-QUOTE / escaped ) QUOTE
              |
              | not-DQUOTE = %x01-21 / %x23-5b / %x5d-7F
              | not-QUOTE = %x01-26 / %x28-5b / %x5d-7F
              | escaped = "\" ( "\" | %x22 | %x27 )

          t
            | The first backslash character of an Escaped sequence is suppressed
            | from the target value, any other character sequence is copied
            | as a verbatim sequence.

          t As an example the euro sign (unicode U+20AC), would be written as follow:
          ul
            li #[tt= '"\\\\20AC"'] being transformed in #[tt= '\\20AC'] to target
              | a CSS value (see #[xref(target='CSS_VALUES') CSS Values 3.3]).
            li #[tt= '"&#x20AC;"'] to target the text-content of a DOM element.

          t String values and lists #[bcp14 SHALL NOT] be interpolated.

      section(anchor='VALUES_INTERPOLATION')
        name Values interpolation

        t
          | Linear and non-linear interpolation is the process that
          | is used to compute graphical-state values (namely target values)
          | whenever logical state properties are modified.

        t
          | This interpolation #[bcp14 MAY] be represented by two steps:
        ol
          li #[xref(target='VI_NORM') A property value normalization].
          li #[xref(target="VI_MAP") A range mapping on the graphical attribute].

        t
          | The steps described are detailed for explanatory purpose, they
          | #[bcp14 MAY] not be directly used, for the sake of performance and
          | precision.

        section(anchor='VI_NORM')
          name Property normalization

          t
            | Property normalization consists in mapping the property value to
            | a normalized #[tt= "[0, 1]"] range.

          t Properties are normalized according to their type:
          ul
            li
              | #[strong number] typed values are linearly mapped according to
              | their #[tt min/max] attributes.
            li
              | #[strong boolean] typed values are mapped on #[tt 0] for false
              | and #[tt 1] for true.
            li
              | #[strong enum] typed values are evenly mapped on the normalized
              | range, the first value being #[tt 0] and the last #[tt 1].

          t
            | The relation element #[xref(target='ELT_RELATION_KEYTIMES') key-times]
            | attribute always refer to this normalized value range.

        section(anchor='VI_MAP')
          name Attribute range mapping

          t
            | The target attribute is mapped from the normalized property value
            | to the target value range.

          t
            | Depending on the #[xref(target='ELT_RELATION_CALC_MODE') calc-mode],
            | the values are either interpolated or stepped into they target
            | range.

          t
            | The #[xref(target='ELT_RELATION_KEYTIMES') key-times] along with
            | the #[xref(target='ELT_RELATION_VALUES') values] attributes are
            | used to split the normalized range in several different target
            | sub-ranges.

          aside
            t
              | As an example, assuming a #[em relation] with #[em values]
              | attribute set to #[tt= '"red; green; blue"'] and a #[em key-times]
              | attribute set to #[tt= '"0; 0.2; 1"'].

            t
              | A normalized property value of #[tt 0.1] would belong to the first
              | target sub-range #[tt= '[0, 0.2[']:
            ul
              li
                | it would be stepped to
                | #[tt red] in #[tt discrete] #[em calc-mode]
              li
                | it would be interpolated to a value exactly in-between
                | #[tt red] and #[tt green] (#[tt 0.1] being normalized as
                | #[tt 0.5] in the #[tt= '[0, 0.2['] range) in
                | #[em linear calc-mode].

            t
              | A normalized property value of #[tt 0.6] would belong to the
              | #[tt= '[0.2, 1['] target sub-range:
            ul
              li it would be stepped to #[tt green] in #[tt discrete] #[em calc-mode]
              li
                | it would be interpolated to a value exactly in-between
                | #[tt green] and #[tt blue] in #[em linear calc-mode].

      //- FIXME: describe direct/strict transition modes
      //- section(anchor='VALUES_TRANSITIONS')
      //-   name Values transitions

    section
      name Contributors
      // Optional section to mention contributors

  back

    references
      name References
      references
        name Normative References
        | &rfc2119;
        | &rfc3629;
        | &rfc5234;

      references
        name Informative References

      references
        name URL References

        reference(anchor='XML_NAMES' target='https://www.w3.org/TR/xml-names')
          front
            title Namespaces in XML 1.0 (Third Edition)
            author
              organization W3C
            date(year='2009')

        reference(anchor='WEB_IDL' target='https://www.w3.org/TR/WebIDL/')
          front
            title WebIDL Level 1
            author
              organization W3C
            date(year='2016')

        reference(anchor='DOM' target='https://www.w3.org/DOM/DOMTR')
          front
            title Document Object Model (DOM)
            author
              organization W3C
            date(year='1998')

        reference(anchor='SVG1_1' target='https://www.w3.org/TR/SVG11')
          front
            title Scalable Vector Graphics (SVG) 1.1 (Second Edition)
            author
              organization W3C
            date(year='2011')

        reference(anchor='SVG2_0' target='https://www.w3.org/TR/SVG2')
          front
            title Scalable Vector Graphics (SVG) 2
            author
              organization W3C
            date(year='2018')

        reference(anchor='SMIL' target='https://www.w3.org/TR/2008/REC-SMIL3-20081201/')
          front
            title Synchronized Multimedia Integration Language (SMIL 3.0)
            author
              organization W3C
            date(year='2008')

        reference(anchor='CSS_SELECTORS' target='https://www.w3.org/TR/selectors-4')
          front
            title CSS Selectors Level 4
            author
              organization W3C
            date(year='2018')

        reference(anchor='CSS_COLOR' target='https://www.w3.org/TR/css-color-3')
          front
            title CSS Color Module Level 3
            author
              organization W3C
            date(year='2018')

        reference(anchor='CSS_TRANSFORMS' target='https://www.w3.org/TR/css-transforms-1')
          front
            title CSS Transforms Module Level 1
            author
              organization W3C
            date(year='2019')

        reference(anchor='CSS_TRANSITIONS' target='https://www.w3.org/TR/css-transitions-1')
          front
            title CSS Transitions
            author
              organization W3C
            date(year='2018')

        reference(anchor='CSS_ANIMATIONS' target='https://www.w3.org/TR/css-animations-1')
          front
            title CSS Animations Level 1
            author
              organization W3C
            date(year='2018')

        reference(anchor='CSS_MOTION' target='https://www.w3.org/TR/motion-1/')
          front
            title Motion Path Module Level 1
            author
              organization W3C
            date(year='2018')

        reference(anchor='CSS_VALUES' target='https://www.w3.org/TR/css3-values')
          front
            title CSS Values and Units Module Level 3
            author
              organization W3C
            date(year='2019')

        reference(anchor='CSS_EASING' target='https://www.w3.org/TR/css-easing-1/')
          front
            title CSS Easing Functions Level 1
            author
              organization W3C
            date(year='2019')

        reference(anchor='WEB_ANIMATION' target='https://www.w3.org/TR/web-animations')
          front
            title Web Animations
            author
              organization W3C
            date(year='2018')

        reference(anchor='RELAX_NG_COMPACT' target='https://relaxng.org/compact-20021121.html')
          front
            title RELAX NG Compact
            author
              organization OASIS
            date(year='2002')

    section
      name Annex

      section
        name About motion paths

        t
          | Objects path animations are not directly supported by this
          | specification, mostly for two reasons:
        ul
          li
            | #[xref(target="SMIL") SMIL animateMotion] that provides object
            | animations along a path are not transforms but animations,
            | thus hard to control and animate out of the interface that
            | SMIL provides (which is really basic).
          li
            | #[xref(target="CSS_MOTION") CSS Motion] which would be really close
            | to what we need is still a draft and is not supported by all browsers.

        t
          | This being said, SSVG users #[bcp14 MAY] use #[tt relation] elements
          | to animate #[tt offset-distance] CSS Motion properties, thus providing
          | motion along path animations for renderers that does support this SVG
          | feature.

        t
          | Stroke path animations and text path animations are also supported
          | using either SVG or CSS dedicated attributes.

        t
          | A later version of this specification #[bcp14 MAY] embed direct
          | path motion.

      section
        name Examples

        section(anchor='EX_RELATION_VALUES')
          name Relation Values example

          figure
            name Relation values example
            sourcecode(type="xml" src="ssvg-specification/relation-values-example.xml")

          t
            | In example above elements with the #[em discrete] class will have:
          ul
            li #[tt opacity=0] when #[tt= '0 <= speed < 125']
            li #[tt opacity=.5] when #[tt= '125 <= speed < 250']
            li #[tt opacity=1] when #[tt= 'speed = 250']

          t
            | Elements with the #[em linear] class will have an opacity that will
            | be proportional to current speed (linear interpolation): #[tt= 'opacity=speed/250'].

          t
            | Since #[tt key-times] is not set, #[tt values] have been evenly spread
            | on the range as if #[tt key-times] was set to #[tt= '0; .25; .75; 1'].

    section
      name Change Log
      t #[strong Rev 1]
      ul
        li first revision.
      t #[strong Rev 2]
      ul
        li Transitions rework: use a more generic syntax.
        li Added #[em attribute-type] on #[tt relation] elements.
        li String parser simplification (not meant to be a unicode parser).
        li path motion statement.
      t #[strong Rev 3 (engine v1.0)]
      ul
        li Lower case all attributes to be DOM compatible
        li default transition type is now "strict"
        li default attribute-name for transforms is "transform"
        li Add 'state' events.
      t #[strong Rev 4 (engine v1.1)]
      ul
        li Updated #[em computed] property #[tt onupdate] arguments (now matches implementation).
        li Added RelationElement DOM interface (#[tt onupdate]).
        li Added #[tt direct] elements.
        li Added #[tt auto] property #[em type].
        li Added non-interpolatable target-values transition requirements.
        li Added requirements on this/window/document in callbacks.

    section
      name Open Issues

      ul
        li
          | Should the default range for number typed property be dynamically
          | computed rather than being bound to #[tt= '[0, 1]'], it would be
          | set to #[tt= '[initial,initial]'] and then possibly extend the range
          | on each update, to be discussed.
